## csound 5.13.0~dfsg

=== SConstruct ===
#J vim:syntax=python
print '''
      C S O U N D 5

SCons build file for Csound 5:
API library, plugin opcodes, utilities, and front ends.

By Michael Gogins <gogins at pipeline dot com>

For custom options, run 'scons -h'.
For default options, run 'scons -H'.
If headers or libraries are not found, edit 'custom.py'.
For Linux, run in the standard shell
    with standard Python and just run 'scons'.
For MinGW, run in the MSys shell
    and use www.python.org WIN32 Python to run scons.
For Microsoft Visual C++, run in the Platform SDK
    command shell, and use www.python.org WIN32 Python to run scons.
'''

import time
import glob
import os
import os.path
import sys
import string
import shutil
import copy

#############################################################################
#
#   UTILITY FUNCTIONS
#
#############################################################################

pluginLibraries = []
executables = []
headers = Split('''
    H/cfgvar.h H/cscore.h H/csdl.h H/csound.h H/csound.hpp H/csoundCore.h
    H/cwindow.h H/msg_attr.h H/OpcodeBase.hpp H/pstream.h H/pvfileio.h
    H/soundio.h H/sysdep.h H/text.h H/version.h H/float-version.h
    interfaces/CsoundFile.hpp interfaces/CppSound.hpp interfaces/filebuilding.h
''')
libs = []
pythonModules = []

def today():
    return time.strftime("%Y-%m-%d", time.localtime())

# Detect OPERATING SYSTEM platform.

def getPlatform():
    if sys.platform[:5] == 'linux':
        return 'linux'
    elif sys.platform[:3] == 'win':
        return 'win32'
    elif sys.platform[:6] == 'darwin':
        return 'darwin'
    elif sys.platform[:5] == 'sunos':
        return 'sunos'
    else:
        return 'unsupported'

#############################################################################
#
#   DEFINE CONFIGURATION
#
#############################################################################

print "System platform is '" + getPlatform() + "'."

# Create options that can be set from the command line.

commandOptions = Options()
commandOptions.Add('CC')
commandOptions.Add('CXX')
commandOptions.Add('LINK')
commandOptions.Add('LINKFLAGS')
commandOptions.Add('custom',
    'Specify name of custom options file (default is "custom.py")',
    'custom.py')
commandOptions.Add('useDouble',
    'Set to 1 to use double-precision floating point for audio samples.',
    '0')
commandOptions.Add('usePortAudio',
    'Set to 1 to use PortAudio for real-time audio input and output.',
    '1')
commandOptions.Add('usePortMIDI',
    'Build PortMidi plugin for real time MIDI input and output.',
    '1')
commandOptions.Add('useALSA',
    'Set to 1 to use ALSA for real-time audio and MIDI input and output.',
    '1')
commandOptions.Add('useJack',
    'Set to 1 if you compiled PortAudio to use Jack; also builds Jack plugin.',
    '1')
commandOptions.Add('useFLTK',
    'Set to 1 to use FLTK for graphs and widget opcodes.',
    '1')
commandOptions.Add('noFLTKThreads',
    'Set to 1 to disable use of a separate thread for FLTK widgets.',
    '1')
commandOptions.Add('pythonVersion',
    'Set to the Python version to be used.',
    '%d.%d' % (int(sys.hexversion) >> 24, (int(sys.hexversion) >> 16) & 255))
commandOptions.Add('buildCsoundVST',
    'Set to 1 to build CsoundVST (needs CsoundAC, FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsoundAC',
    'Set to 1 to build CsoundAC (needs FLTK, boost, Python, SWIG).',
    '0')
commandOptions.Add('buildCsound5GUI',
    'Build FLTK GUI frontend (requires FLTK 1.1.7 or later).',
    '0')
commandOptions.Add('generateTags',
    'Set to 1 to generate TAGS',
    '0')
commandOptions.Add('generatePdf',
    'Set to 1 to generate PDF documentation',
    '0')
commandOptions.Add('buildLoris',
    'Set to 1 to build the Loris Python extension and opcodes',
    '1')
commandOptions.Add('useOSC',
    'Set to 1 if you want OSC support',
    '0')
commandOptions.Add('bufferoverflowu',
    'Set to 1 to use the Windows buffer overflow library, required if you use MinGW to link with MSVC-built libraries',
    '0')
if getPlatform() != 'win32':
    commandOptions.Add('useUDP',
        'Set to 0 if you do not want UDP support',
        '1')
else:
    commandOptions.Add('useUDP',
        'Set to 1 if you want UDP support',
        '0')
commandOptions.Add('buildPythonOpcodes',
    'Set to 1 to build Python opcodes',
    '0')
commandOptions.Add('prefix',
    'Base directory for installs. Defaults to /usr/local.',
    '/usr/local')
commandOptions.Add('instdir',
    'For the install target: puts instdir before the prefix',
    '')
commandOptions.Add('buildRelease',
    'Set to 1 to build for release (implies noDebug).',
    '0')
commandOptions.Add('noDebug',
    'Build without debugging information.',
    '0')
commandOptions.Add('gcc3opt',
    'Enable gcc 3.3.x or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('gcc4opt',
    'Enable gcc 4.0 or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
commandOptions.Add('useLrint',
    'Use lrint() and lrintf() for converting floating point values to integers.',
    '0')
commandOptions.Add('useGprof',
    'Build with profiling information (-pg).',
    '0')
commandOptions.Add('Word64',
    'Build for 64bit computer',
    '0')
commandOptions.Add('Lib64',
    'Build for lib64 rather than lib',
    '0')
if getPlatform() == 'win32':
    commandOptions.Add('dynamicCsoundLibrary',
        'Set to 0 to build static Csound library instead of csound.dll',
        '1')
else:
    commandOptions.Add('dynamicCsoundLibrary',
        'Build dynamic Csound library instead of libcsound.a',
        '0')
commandOptions.Add('buildStkOpcodes',
    "Build opcodes encapsulating Perry Cook's Synthesis Toolkit in C++ instruments and effects",
    '0')
commandOptions.Add('install',
    'Enables the Install targets',
    '0')
commandOptions.Add('buildPDClass',
    "build csoundapi~ PD class (needs m_pd.h in the standard places)",
    '0')
commandOptions.Add('useCoreAudio',
    "Set to 1 to use CoreAudio for real-time audio input and output.",
    '1')
commandOptions.Add('useAltivec',
    "On OSX use the gcc AltiVec optmisation flags",
    '0')
commandOptions.Add('buildDSSI',
    "Build DSSI/LADSPA host opcodes",
    '1')
commandOptions.Add('buildUtilities',
    "Build stand-alone executables for utilities that can also be used with -U",
    '1')
commandOptions.Add('buildTclcsound',
    "Build Tclcsound frontend (cstclsh, cswish and tclcsound dynamic module). Requires Tcl/Tk headers and libs",
    '0')
commandOptions.Add('buildWinsound',
    "Build Winsound frontend. Requires FLTK headers and libs",
    '0')
commandOptions.Add('buildVirtual',
    "Build Virtual MIDI keyboard. Requires FLTK 1.1.7 or later headers and libs",
    '0')
commandOptions.Add('buildInterfaces',
    "Build C++ interface library.",
    '0')
commandOptions.Add('buildLuaWrapper',
    'Set to 1 to build Lua wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildPythonWrapper',
    'Set to 1 to build Python wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildJavaWrapper',
    'Set to 1 to build Java wrapper for the C++ interface library (needs buildInterfaces).',
    '0')
commandOptions.Add('buildOSXGUI',
    'On OSX, set to 1 to build the basic GUI frontend',
    '0')
commandOptions.Add('buildCSEditor',
    'Set to 1 to build the Csound syntax highlighting text editor. Requires FLTK headers and libs',
    '0')
commandOptions.Add('withICL',
    'On Windows, set to 1 to build with the Intel C++ Compiler (also requires Microsoft Visual C++), or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withMSVC',
    'On Windows, set to 1 to build with Microsoft Visual C++, or set to 0 to build with MinGW',
    '0')
commandOptions.Add('withSunStudio',
    'On Solaris, set to 1 to build with Sun Studio, or set to 0 to build with gcc',
    '1')
commandOptions.Add('buildNewParser',
    'Enable building new parser (requires Flex/Bison)',
    '1')
commandOptions.Add('NewParserDebug',
    'Enable tracing of new parser',
    '0')
commandOptions.Add('buildvst4cs',
    'Set to 1 to build vst4cs plugins (requires Steinberg VST headers)',
    '0')
if getPlatform() == 'win32':
  commandOptions.Add('useGettext',
    'Set to 1 to use the GBU internationalisation/localisation scheme',
    '0')
else:
  commandOptions.Add('useGettext',
    'Set to 0 for none and 1 for GNU internationalisation/localisation scheme',
    '1')
commandOptions.Add('buildImageOpcodes',
    'Set to 0 to avoid building image opcodes',
    '1')
commandOptions.Add('useOpenMP',
    'Set to 1 to use OpenMP for parallel performance',
    '0')
##### JPff for OLPC #####
commandOptions.Add('buildOLPC',
    'Set to 1 to build OLPC version',
    '0')
commandOptions.Add('tclversion',
    'Set to 8.4 or 8.5',
    '8.4')
commandOptions.Add('includeMP3',
     'Set to 1 if using mpadec',
     '0')
commandOptions.Add('includeWii',
     'Set to 1 if using libwiimote',
     '0')
commandOptions.Add('includeP5Glove',
     'Set to 1 if using P5 Glove',
     '0')
commandOptions.Add('buildBeats',
     'Set to 1 if building beats score language',
     '0')

# Define the common part of the build environment.
# This section also sets up customized options for third-party libraries, which
# should take priority over default options.

commonEnvironment = Environment(ENV = os.environ)
commandOptions.Update(commonEnvironment)

def compilerIntel():
    if getPlatform() == 'win32' and commonEnvironment['withICL'] == '1':
        return True
    else:
        return False

def compilerMicrosoft():
    if getPlatform() == 'win32' and commonEnvironment['withMSVC'] == '1':
        return True
    else:
        return False

def compilerSun():
    if getPlatform() == 'sunos' and commonEnvironment['withSunStudio'] == '1':
        return True
    else:
        return False

def compilerGNU():
    if not compilerIntel() and not compilerMicrosoft() and not compilerSun():
        return True
    else:
        return False

optionsFilename = 'custom.py'

if compilerIntel():
	Tool('icl')(commonEnvironment)
	optionsFilename = 'custom-msvc.py'
elif compilerMicrosoft():
	optionsFilename = 'custom-msvc.py'
elif getPlatform() == 'win32':
	# On Windows, to exclude MSVC tools,
	# we have to force MinGW tools and then re-create
	# the environment from scratch.
	commonEnvironment = Environment(ENV = os.environ, tools = ['mingw', 'swig', 'javac', 'jar'])
	commandOptions.Update(commonEnvironment)
	#Tool('mingw')(commonEnvironment)
	optionsFilename = 'custom-mingw.py'

Help(commandOptions.GenerateHelpText(commonEnvironment))

if commonEnvironment['custom']:
    optionsFilename = commonEnvironment['custom']

print "Using options from '%s.'" % optionsFilename

fileOptions = Options(optionsFilename)
fileOptions.Add('customCPPPATH', 'List of custom CPPPATH variables')
fileOptions.Add('customCCFLAGS')
fileOptions.Add('customCXXFLAGS')
fileOptions.Add('customLIBS')
fileOptions.Add('customLIBPATH')
fileOptions.Add('customSHLINKFLAGS')
fileOptions.Add('customSWIGFLAGS')
fileOptions.Update(commonEnvironment)

customCPPPATH = commonEnvironment['customCPPPATH']
commonEnvironment.Prepend(CPPPATH = customCPPPATH)
customCCFLAGS = commonEnvironment['customCCFLAGS']
commonEnvironment.Prepend(CCFLAGS = customCCFLAGS)
customCXXFLAGS = commonEnvironment['customCXXFLAGS']
commonEnvironment.Prepend(CXXFLAGS = customCXXFLAGS)
customLIBS = commonEnvironment['customLIBS']
commonEnvironment.Prepend(LIBS = customLIBS)
customLIBPATH = commonEnvironment['customLIBPATH']
commonEnvironment.Prepend(LIBPATH = customLIBPATH)
customSHLINKFLAGS = commonEnvironment['customSHLINKFLAGS']
commonEnvironment.Prepend(SHLINKFLAGS = customSHLINKFLAGS)
customSWIGFLAGS = commonEnvironment['customSWIGFLAGS']
commonEnvironment.Prepend(SWIGFLAGS = customSWIGFLAGS)

=== pluginSDK/SConstruct ===

# vim:syntax=python

print '''
C S O U N D 5 - PLUGIN BUILD FILE

SCons build file for Csound 5 Plugins
By Steven Yi <stevenyi at gmail dot com>

based on Csound5 SConstruct file by Michael Gogins

For custom options, run 'scons -h'.
For default options, run 'scons -H'.
If headers or libraries are not found, edit 'custom.py'.
For Linux, run in the standard shell
    with standard Python and just run 'scons'.
For MinGW, run in the MSys shell
    and use www.python.org WIN32 Python to run scons.
'''

import time
import glob
import os
import os.path
import sys
import string
import zipfile
import shutil
import copy

#############################################################################
#
#   UTILITY FUNCTIONS
#
#############################################################################

zipDependencies = []
pluginLibraries = []
executables = []

libs = []
pythonModules = []

def today():
    return time.strftime("%Y-%m-%d", time.localtime())

def getPlatform():
    if sys.platform[:5] == 'linux':
        return 'linux'
    elif sys.platform[:3] == 'win':
        return 'win32'
    elif sys.platform[:6] == 'darwin':
        return 'darwin'
    else:
        return 'unsupported'

def withMSVC():
    if getPlatform() != 'win32':
           return 0
    checkenv = Environment()
    if 'msvc' in checkenv['TOOLS']: # MSVC
           return 1
    else:
           return 0

#############################################################################
#
#   DEFINE CONFIGURATION
#
#############################################################################

# Detect platform.

print "System platform is '" + getPlatform() + "'."
# Define configuration options.
if withMSVC():
 opts = Options('custom-msvc.py')
else:
 opts = Options('custom.py')
opts.Add('CC')
opts.Add('CXX')
opts.Add('LINK')
opts.Add('LINKFLAGS')
opts.Add('customCPPPATH', 'List of custom CPPPATH variables')
opts.Add('customCCFLAGS')
opts.Add('customCXXFLAGS')
opts.Add('customLIBS')
opts.Add('customLIBPATH')
opts.Add('customSHLINKFLAGS')
opts.Add('customSWIGFLAGS')
opts.Add('useDouble',
    'Set to 1 to use double-precision floating point for audio samples.',
    '0')
opts.Add('buildRelease',
    'Set to 1 to build for release (implies noDebug).',
    '0')
opts.Add('noDebug',
    'Build without debugging information.',
    '0')
opts.Add('gcc3opt',
    'Enable gcc 3.3.x or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
opts.Add('gcc4opt',
    'Enable gcc 4.0 or later optimizations for the specified CPU architecture (e.g. pentium3); implies noDebug.',
    '0')
opts.Add('useLrint',
    'Use lrint() and lrintf() for converting floating point values to integers.',
    '0')
opts.Add('useGprof',
    'Build with profiling information (-pg).',
    '0')
opts.Add('Word64',
    'Build for 64bit computer',
    '0')
if not withMSVC:
   def_intfc = '1'
else:
   def_intfc = '0'

# Define the common part of the build environment.
# This section also sets up customized options for third-party libraries, which
# should take priority over default options.

commonEnvironment = Environment(options = opts, ENV = {'PATH' : os.environ['PATH']})

customCPPPATH = commonEnvironment['customCPPPATH']
commonEnvironment.Prepend(CPPPATH = customCPPPATH)
customCCFLAGS = commonEnvironment['customCCFLAGS']
commonEnvironment.Prepend(CCFLAGS = customCCFLAGS)
customCXXFLAGS = commonEnvironment['customCXXFLAGS']
commonEnvironment.Prepend(CXXFLAGS = customCXXFLAGS)
customLIBS = commonEnvironment['customLIBS']
commonEnvironment.Prepend(LIBS = customLIBS)
customLIBPATH = commonEnvironment['customLIBPATH']
commonEnvironment.Prepend(LIBPATH = customLIBPATH)
customSHLINKFLAGS = commonEnvironment['customSHLINKFLAGS']
commonEnvironment.Prepend(SHLINKFLAGS = customSHLINKFLAGS)
customSWIGFLAGS = commonEnvironment['customSWIGFLAGS']
commonEnvironment.Prepend(SWIGFLAGS = customSWIGFLAGS)

Help(opts.GenerateHelpText(commonEnvironment))

# Define options for different platforms.
if getPlatform() != 'win32':
 print "Build platform is '" + getPlatform() + "'."
else:
 if not withMSVC():
  print "Build platform is 'mingw/msys'"
 else:
  print "Build platform is 'msvc'"

print "SCons tools on this platform: ", commonEnvironment['TOOLS']


commonEnvironment.Prepend(CPPPATH = ['.', './H'])
if commonEnvironment['useLrint'] != '0':
  commonEnvironment.Prepend(CCFLAGS = ['-DUSE_LRINT'])
if commonEnvironment['gcc3opt'] != '0' or commonEnvironment['gcc4opt'] != '0':
  if commonEnvironment['gcc4opt'] != '0':
    commonEnvironment.Prepend(CCFLAGS = ['-ftree-vectorize'])
    cpuType = commonEnvironment['gcc4opt']
  else:
    cpuType = commonEnvironment['gcc3opt']
  commonEnvironment.Prepend(CCFLAGS = ['-fomit-frame-pointer', '-ffast-math'])
  if getPlatform() == 'darwin':
    flags = '-O3 -mcpu=%s -mtune=%s'%(cpuType, cpuType)
  else:
    flags = '-O3 -march=%s'%(cpuType)
  commonEnvironment.Prepend(CCFLAGS = Split(flags))
elif commonEnvironment['buildRelease'] != '0':
  if not withMSVC():
    commonEnvironment.Prepend(CCFLAGS = Split('''
      -O3 -fno-inline-functions -fomit-frame-pointer -ffast-math
    '''))
elif commonEnvironment['noDebug'] == '0':
  if getPlatform() == 'darwin':
    commonEnvironment.Prepend(CCFLAGS = ['-g', '-O2'])
  else:
    if not withMSVC():
      commonEnvironment.Prepend(CCFLAGS = ['-g', '-gstabs', '-O2'])
else:
  commonEnvironment.Prepend(CCFLAGS = ['-O2'])
if commonEnvironment['useGprof'] == '1':
  commonEnvironment.Append(CCFLAGS = ['-pg'])
  commonEnvironment.Append(LINKFLAGS = ['-pg'])
if not withMSVC():
  commonEnvironment.Prepend(CXXFLAGS = ['-fexceptions'])
commonEnvironment.Prepend(LIBPATH = ['.', '#.'])
if commonEnvironment['buildRelease'] == '0':
    commonEnvironment.Prepend(CPPFLAGS = ['-DBETA'])
if commonEnvironment['Word64'] == '1':
    commonEnvironment.Prepend(LIBPATH = ['.', '#.', '/usr/local/lib64'])
    commonEnvironment.Append(CCFLAGS = ['-fPIC'])
else:
    commonEnvironment.Prepend(LIBPATH = ['.', '#.', '/usr/local/lib'])

if commonEnvironment['useDouble'] == '0':
    print 'CONFIGURATION DECISION: Using single-precision floating point for audio samples.'
else:
    print 'CONFIGURATION DECISION: Using double-precision floating point for audio samples.'
    commonEnvironment.Append(CPPFLAGS = ['-DUSE_DOUBLE'])

# Define different build environments for different types of targets.

if not withMSVC():
    commonEnvironment.Prepend(CCFLAGS = "-Wall")

if getPlatform() == 'linux':
    commonEnvironment.Append(CCFLAGS = "-DLINUX")
    commonEnvironment.Append(CPPPATH = '/usr/local/include')
    commonEnvironment.Append(CPPPATH = '/usr/include')
    commonEnvironment.Append(CPPPATH = '/usr/X11R6/include')
    commonEnvironment.Append(CCFLAGS = "-DPIPES")
    commonEnvironment.Append(LINKFLAGS = ['-Wl,-Bdynamic'])
elif getPlatform() == 'darwin':
    commonEnvironment.Append(CCFLAGS = "-DMACOSX")
    commonEnvironment.Append(CPPPATH = '/usr/local/include')
    commonEnvironment.Append(CCFLAGS = "-DPIPES")
    if commonEnvironment['useAltivec'] == '1':
        print 'CONFIGURATION DECISION using Altivec optmisation'
        commonEnvironment.Append(CCFLAGS = "-faltivec")
elif getPlatform() == 'win32':
    commonEnvironment.Append(CCFLAGS = "-D_WIN32")
    commonEnvironment.Append(CCFLAGS = "-DWIN32")
    commonEnvironment.Append(CCFLAGS = "-DPIPES")
    commonEnvironment.Append(CCFLAGS = "-DOS_IS_WIN32")
    if not withMSVC():
        commonEnvironment.Append(CPPPATH = '/usr/local/include')
        commonEnvironment.Append(CPPPATH = '/usr/include')
        commonEnvironment.Append(CCFLAGS = "-mthreads")
    else:
        commonEnvironment.Append(CCFLAGS = "-DMSVC")

# Check for prerequisites.
# We check only for headers; checking for libs may fail
# even if they are present, due to secondary dependencies.

configure = commonEnvironment.Configure()

if not configure.CheckHeader("stdio.h", language = "C"):
    print " *** Failed to compile a simple test program. The compiler is"
    print " *** possibly not set up correctly, or is used with invalid flags."
    print " *** Check config.log to find out more about the error."
    Exit(-1)

if getPlatform() == 'win32':
    commonEnvironment['ENV']['PATH'] = os.environ['PATH']
    commonEnvironment['SYSTEMROOT'] = os.environ['SYSTEMROOT']

# Define macros that configure and config.h used to define.

headerMacroCheck = [
    ['io.h',        '-DHAVE_IO_H'       ],
    ['fcntl.h',     '-DHAVE_FCNTL_H'    ],
    ['unistd.h',    '-DHAVE_UNISTD_H'   ],
    ['stdint.h',    '-DHAVE_STDINT_H'   ],
    ['sys/time.h',  '-DHAVE_SYS_TIME_H' ],
    ['sys/types.h', '-DHAVE_SYS_TYPES_H'],
    ['termios.h',   '-DHAVE_TERMIOS_H'  ]]

for h in headerMacroCheck:
    if configure.CheckHeader(h[0], language = "C"):
        commonEnvironment.Append(CPPFLAGS = [h[1]])

if getPlatform() == 'darwin':
    commonEnvironment.Append(CPPFLAGS = '-DHAVE_DIRENT_H')
elif configure.CheckHeader("dirent.h", language = "C"):
    commonEnvironment.Append(CPPFLAGS = '-DHAVE_DIRENT_H')


def makePlugin(env, pluginName, srcs):
    pluginLib = env.SharedLibrary(pluginName, srcs)
    pluginLibraries.append(pluginLib)
    
    return pluginLib

pluginEnvironment = commonEnvironment.Copy()
#pluginEnvironment.Append(LIBS = ['sndfile'])

if getPlatform() == 'darwin':
    pluginEnvironment.Append(LINKFLAGS = Split('''
        -framework CoreMidi -framework CoreFoundation -framework CoreAudio
    '''))
    # pluginEnvironment.Append(LINKFLAGS = ['-dynamiclib'])
    pluginEnvironment['SHLIBSUFFIX'] = '.dylib'
    pluginEnvironment.Prepend(CXXFLAGS = "-fno-rtti")

#############################################################################
#
#   DEFINE TARGETS AND SOURCES
#
#############################################################################

# Plugin opcodes.

makePlugin(pluginEnvironment, 'examplePlugin', Split('''
    examplePlugin.c
'''))

=== examples/java/Makefile ===

all: CSDPlayer.jar CsoundEditor.jar

CSDPlayer.jar: CSDPlayer.java CSDPlayer.mf
	-rm -r *.class csnd/*
	-rmdir csnd
	javac -classpath ../../csnd.jar $<
	jar xf ../../csnd.jar csnd
	jar cfm $@ CSDPlayer.mf csnd *.class
	jar i $@
	-rm -r *.class csnd/*
	-rmdir csnd

CsoundEditor.jar: CsoundEditor.java CsoundEditor.mf
	-rm -r *.class csnd/*
	-rmdir csnd
	javac -classpath ../../csnd.jar $<
	jar xf ../../csnd.jar csnd
	jar cfm $@ CsoundEditor.mf csnd *.class
	jar i $@
	-rm -r *.class csnd/*
	-rmdir csnd

clean:
	-rm *.jar *.class csnd/*
	-rmdir csnd

=== frontends/beats/Makefile ===
SRC = beats.tab.c lex.yy.c main.c
OBJ = beats.tab.o lex.yy.o main.o

all:	beats

beats:	$(OBJ)
	gcc -g -o beats $(OBJ) -lm

lex.yy.c:	beats.l beats.tab.h
	flex beats.l

lex.yy.o:	lex.yy.c beats.tab.h
	gcc -g -c lex.yy.c

beats.tab.c:	beats.y
	bison -d beats.y

beats.tab.o:	beats.tab.c
	gcc -g -c beats.tab.c

main.o:	main.c
	gcc -g -c main.c

clean:
	rm -rf main.o beats.tab.o beats.tab.c beats.tab.h lex.yy.o lex.yy.c \
	beats makefile

dist:
	zip beats.zip  beats.l  beats.y main.c Makefile test.xs

makefile: Makefile $(SRC)
	gcc -M $(SRC) | cat Makefile - > makefile

=== debian/changelog ===
csound (1:5.13.0~dfsg-4ubuntu1) oneiric; urgency=low

  * Change build-dep from swig to swig2.0 (swig1.3 makes the package
    FTBFS) since we won't be transitioning to swig 2.0 for oneiric
    - update debian/control
    - update debian/rules

 -- Micah Gersten <micahg@ubuntu.com>  Fri, 05 Aug 2011 13:02:45 -0500

csound (1:5.13.0~dfsg-4) unstable; urgency=low

  [ Alessio Treglia ]
  * Switch to dh_python2
    - Update fail-missing rule to ignore files installed in /usr/lib/pyshared.
  * debian/custom.py: Small fix to set -Wl,--as-needed properly.
  * libcsound64-doc provides documentation in HTML format,
    fix package description.
  * Register documentation with doc-base.

  [ Felipe Sateler ]
  * Create new package csound-data for common data files.
    - Put the HRTF data files there (LP: #225639)
  * Drop the dependency on a JRE for libcsnd-java, the policy no longer
    requires it.
  * Merge Jakub Wilk's NMU changes.
  * Build only for the default python version
  * Delete doxygen stamp on clean. Closes: #632256.
  * Bump standards-version (No changes needed).

 -- Felipe Sateler <fsateler@debian.org>  Wed, 13 Jul 2011 23:31:22 -0400

csound (1:5.13.0~dfsg-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * In order to fix FTBFS with GCC, don't append --no-export-all-symbols to
    SHLINKFLAGS 4.6 (closes: #624982). Thanks to Lucas Nussbaum for the bug
    report.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 26 Jun 2011 20:41:04 +0200

csound (1:5.13.0~dfsg-3) unstable; urgency=low

  * Beats needs bison and flex in order to build (Closes: #613933)
  * Install the beats executable in the csound package

 -- Felipe Sateler <fsateler@debian.org>  Mon, 21 Feb 2011 17:42:50 -0300

csound (1:5.13.0~dfsg-2) unstable; urgency=low

   * Upload to unstable.
 -- Felipe Sateler <fsateler@debian.org>  Thu, 10 Feb 2011 11:54:10 -0300

csound (1:5.13.0~dfsg-1) experimental; urgency=low

  [ Jonas Smedegaard ]
  * Let CDBS resolve if parallel build is enabled.
  * Ease building with git-buildpackage:
    + Git-ignore quilt .pc dir.
    + Add dpkg-source local-options.

  [ Felipe Sateler ]
  * New Upstream release
    - Update symbols file
    - Drop patches grabbed from upstream development
    - Add patch to fix linkage of csoundac to csnd
    - Refresh other patches
    - Enable the new Beats score language

 -- Felipe Sateler <fsateler@debian.org>  Mon, 17 Jan 2011 22:56:00 -0300

=== debian/control ===
Source: csound
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Felipe Sateler <fsateler@debian.org>, Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.73~),
 scons,
 debhelper (>= 6),
 dh-buildinfo,
 python (>= 2.6.5),
 devscripts (>= 2.10.7~),
 libsndfile1-dev,
 libasound2-dev [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386],
 libjack-dev,
 portaudio19-dev,
 libportmidi-dev,
 libpulse-dev,
 swig2.0,
 liblua5.1-0-dev,
 tk-dev,
 tcl-dev,
 python-dev (>= 2.6.6-3~),
 puredata-dev,
 default-jdk,
 libfltk1.1-dev,
 libfluidsynth-dev,
 liblo-dev,
 fluid,
 ladspa-sdk,
 libboost-dev,
 libboost-serialization-dev,
 libpng12-dev,
 dssi-dev,
 libstk0-dev,
 libgmm++-dev,
 bison,
 flex,
 doxygen,
 graphviz,
 ttf-dejavu
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-multimedia/csound
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/csound.git;a=summary
Homepage: http://www.csounds.com

Package: csound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcsound64-5.1 (<< 1:5.08.2~dfsg-1)
Recommends: csound-gui, csound-utils, csound-manpages
Description: powerful and versatile sound synthesis software
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.

Package: csound-data
Architecture: all
Depends: ${misc:Depends}
Breaks: csound (<< 1:5.13.0~dfsg-4)
Description: data files used by the csound library
 This package includes the architecture-independent data files used by
 the csound library or plugins.
 .
 For more information on Csound see the csound package.

Package: csound-gui
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: GUI interfaces and opcodes for Csound
 This package includes the GUI interfaces for Csound: winsound,
 cseditor and csound5gui, plus the GUI opcodes.
 .
 For more information on Csound, see the csound package.

Package: csound-utils
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: miscellaneous utilities for the Csound system
 This package contains several utilities which may be useful with
 Csound.
 These utilities aid in score creation, sound analysis and sound 
 transformations.

Package: libcsound64-5.2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, csound-data
Recommends: csound
Breaks: csound (<< 1:5.07.0.dfsg-1)
Description: main library for Csound
 This package contains the library which provides most of the Csound
 functionality. This library was built using 64-bit precision for the
 calculations (this doesn't mean you need a 64-bit processor).
 .
 For more information on Csound, see the csound package.

Package: libcsnd-java
Architecture: any
Section: java
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: csound
Suggests: java-virtual-machine
Description: Java bindings for the Csound API
 These are the java bindings for the Csound API.
 .
 For more information on Csound, see the csound package

Package: libcsound64-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsound64-5.2 (>= ${source:Version}), libcsound64-5.2 (<< ${source:Version}.1~), ${misc:Depends}
Description: development files for Csound
 This package contains the development files needed to build programs
 linking to the Csound library.
 .
 For more information on Csound, see the csound package.

Package: libcsnd-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsnd5.2 (>= ${source:Version}), libcsnd5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsnd5.1
Suggests: liblua5.1-luacsnd5.2
Provides: liblua5.1-luacsnd-dev
Description: development files for Csound -- C++ API
 This package contains the development files needed to build programs
 using the C++ bindings to the Csound library. It also includes the
 development symlink for the lua module, but you have to manually
 install liblua5.1-luacsnd5.2 for that to work.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac-dev
Architecture: all
Priority: extra
Section: libdevel
Depends: libcsoundac5.2 (>= ${source:Version}), libcsoundac5.2 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsoundac5.1
Description: development files for CsoundAC
 This package contains the development files needed to build programs
 using the CsoundAC algorithmic composition system.
 .
 For more information on Csound and CsoundAC, see the csound and
 csoundac packages.

Package: pd-csound
Architecture: any
Depends: csound, puredata | pd, ${shlibs:Depends}, ${misc:Depends}
Description: Csound external for PureData
 This is the csoundapi~ opcode for PureData.
 .
 For more information on Csound or pureData, see the respective
 packages.

Package: python-csound
Architecture: any
Section: python
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for Csound
 This is the Python binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ bindings for the Csound API
 This is the C++ binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: liblua5.1-luacsnd5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: liblua5.1-csnd
Description: Lua bindings for the Csound API
 This is the Lua binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: tclcsound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tcl bindings and interpreters for Csound
 This package contains the Tcl interfaces to Csound. It includes:
  - tclcsound: the Csound Tcl interface.
  - cswish: Csound wish interpreter
  - cstclsh: Csound Tcl interpreter
 .
 For more information on Csound or Tcl, see the respective packages.

Package: libcsoundac5.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: the Csound Algorithmic Composition library
 This is the core library for CsoundAC. It provides all the CsoundAC
 functionality. It also contains the development files to create C++
 programs.
 .
 For more information on Csound, see the csound package.

Package: python-csoundac
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, python-csound, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for CsoundAC
 This is the Python interface to the Csound Algorithmic Composition
 library.
 .
 For more information on Csound, see the csound package.

Package: csladspa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ladspa-plugin
Description: LADSPA plugin for Csound
 This plugin enables the creation of LADSPA plugins with the Csound
 language.
 .
 For more information on Csound or LADSPA, see the csound or ladspa-sdk
 packages, respectively.

Package: libcsound64-doc
Architecture: all
Priority: extra
Section: doc
Depends: ${misc:Depends}
Recommends: csound, libcsound64-dev
Description: Csound API documentation
 This package contains the API documentation for the Csound library in
 HTML format.
 .
 For more information on Csound, see the csound package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2009 Felipe Sateler <fsateler@gmail.com>
# Copyright © 2008-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for CSound
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DEB_PYTHON_MODULE_PACKAGES = python-csound python-csoundac
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-module.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_UPSTREAM_URL = http://downloads.sourceforge.net/csound

# Adjustments for unusual upstream tarballs:
# * capitalized project name
# * no dash between project name and version
# * version number included in top folder inside tarball
DEB_UPSTREAM_PACKAGE = Csound
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/\-//g

DEB_UPSTREAM_TARBALL_MD5 = 6c123822e3396f136d6eeea0f801a495

# Non-DFSG license: limited to educational and research purposes
DEB_UPSTREAM_REPACKAGE_EXCLUDES = ./Opcodes/scansyn*
# Embedded tarball contains possibly source-less python binary
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./csound5_osx_installer_files.tar.gz
# Contains explicit copyright but lack licensing info
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./samples/VintageDreamsWaves-v2.sf2

# Common docs for all packages
DEB_INSTALL_DOCS_ALL = readme-csound5.txt AUTHORS

# Core options of csound
DEB_SCONS_OPTIONS = \
	dynamicCsoundLibrary=1 \
	useDouble=1 \
	buildNewParser=0 \
	NewParserDebug=0 \
	useGettext=1 \
	buildRelease=1 \
	buildUtilities=1 \
	noDebug=0 \
	useLrint=0 \
	Word64=0 \
	Lib64=0 \
	useAltivec=0 \
	useOpenMP=0 \
	withICL=0 \
	withMSVC=0 \
	withSunStudio=0 \
	prefix=/usr \
	generatePdf=0 \
	generateTags=0 \
	bufferoverflowu=0 \
	LINKFLAGS='-Wl,-as-needed' \
	SHLINKFLAGS='-Wl,-as-needed'

# I/O plugins
DEB_SCONS_OPTIONS += \
	useCoreAudio=0 \
	usePortAudio=1 \
	usePortMIDI=1 \
	useJack=1 \
	buildVirtual=1  # Virtual MIDI keyboard
# PulseAudio does not have an option
ifeq "$(DEB_HOST_ARCH_OS)" "linux"
	DEB_SCONS_OPTIONS += useALSA=1
else
	DEB_SCONS_OPTIONS += useALSA=0
endif

# Optional opcodes
DEB_SCONS_OPTIONS += \
	useFLTK=1 \
	noFLTKThreads=1 \
	useOSC=1 \
	buildPythonOpcodes=1 \
	buildDSSI=1 \
	buildLoris=0 \
	useUDP=1 \
	buildStkOpcodes=1 \
	buildvst4cs=0 \
	includeMP3=0 \
	includeWii=0 \
	includeP5Glove=0 \
	buildImageOpcodes=1

# Language Wrappers
# TODO: build for all Python versions (not only current default one)
# Force build of only the default one
# UGLY HACK: abuse this variable to pass an appropriate -V option
DEB_PYTHON_PRIVATE_MODULES_DIRS = -V $(shell pyversions -vd)
TCLVERSION := $(shell dpkg -l tcl-dev | sed -n 's/.*\(8\.[45]\)\..*/\1/p')
DEB_SCONS_OPTIONS += \
	buildInterfaces=1 \
	buildJavaWrapper=1 \
	buildPythonWrapper=1 \
	pythonVersion=$(cdbs_python_current_version) \
	buildLuaWrapper=1 \
	buildTclcsound=1 \
	tclversion=$(TCLVERSION) \
	buildPDClass=1

# Frontends
DEB_SCONS_OPTIONS += \
	buildBeats=1 \
	buildCSEditor=0 \
	buildCsoundAC=1 \
	buildCsoundVST=0 \
	buildCsound5GUI=0 \
	buildOSXGUI=0 \
	buildWinsound=1


# This is a huge optimization boost
ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	DEB_SCONS_OPTIONS += gcc4opt=generic
endif

# Python >= 2.6 should install to dist-packages instead of site-packages
# Since 2.5 is the only version < 2.6 we support, we test for that.
# TODO: Use simpler second form when 2.6 is default in a stable release
PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/$(if $(call cdbs_streq,$(cdbs_python_current_version),2.5),site-packages,dist-packages)
#PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/dist-packages

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX = $(DEB_HOST_GNU_TYPE)-g++

# Support parallel building if enabled in DEB_BUILD_OPTIONS
NJOBS = $(DEB_PARALLEL_JOBS:%=-j%)

DEB_DH_INSTALL_SOURCEDIR = debian/tmp

fltk-orig-files := $(shell find * -type f -name '*.fl')
fltk-autofiles = $(fltk-orig-files:.fl=.cpp) $(fltk-orig-files:.fl=.cxx) $(fltk-orig-files:.fl=.hpp) $(fltk-orig-files:.fl=.h)
swig-autofiles = interfaces/python_interface_wrap.cc interfaces/python_interface_wrap.h
upstreamtmpfiles = custom.py $(fltk-autofiles) $(swig-autofiles) doc/latex/doxygen.sty

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl::
	cp --remove-destination debian/custom.py custom.py

DEB_SCONS_BUILD_OPTIONS = $(NJOBS)

DEB_SCONS_INSTALL_OPTIONS = instdir=$(CURDIR)/debian/tmp
DEB_SCONS_INSTALL_TARGET = install=1


install/libcsound64-doc:: build-doxygen-stamp
build-doxygen-stamp:
	doxygen
	touch $@

# Put aside upstream cruft before build but after licensecheck
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff:
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || mv -v $$file $$file.upstream; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir ] || [ -e $$dir.upstream ] || mv -v $$dir $$dir.upstream; \
	done
	touch $@

# Revert upstream cruft that was put aside during build
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -v -f $$file.upstream $$file; \
	done
	for dir in $(upstreamtmpdirs); do \
		[ ! -e $$dir.upstream ] || mv -v -f $$dir.upstream $$dir; \
	done
	rm -f debian/stamp-upstreamtmpstuff

clean::
	rm -f build-arch-stamp build-indep-stamp manpages-stamp \
		build-doxygen-stamp
# and there still is stuff that doesn't get deleted.
	rm -f interfaces/*.java
	rm -f interfaces/*_interface_wrap.*
	rm -f frontends/CsoundVST/CsoundVST_wrap.h
	rm -f frontends/CsoundAC/CsoundAC_wrap.h
	rm -f lib_CsoundVST.so CsoundVST.py
	rm -f libcsound64.so
	rm -f libcsound64.so.5
	rm -f frontends/cseditor/cseditor.o
	rm -f libcsnd.so
	rm -f CsoundAC.py lib_CsoundAC.so
	rm -f frontends/CsoundAC/*.os
	rm -f libCsoundAC.so*
	rm -rf doc/html
	rm -f csnd.py
# Localisation stuff
	rm -rf po/*/
# fail-missing stuff
	rm -f debian/cdbs-install-diff
	rm -f debian/cdbs-reduced-install-list
	rm -f debian/cdbs-reduced-package-list

install/csound-data::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/locale
	cp -r po/*/ $(CURDIR)/debian/tmp/usr/share/locale
	mkdir -p $(CURDIR)/debian/tmp/usr/share/csound/hrtf
	cp samples/*.dat $(CURDIR)/debian/tmp/usr/share/csound/hrtf

# Scons sucks
install/libcsound64-dev::
	ln -sf libcsound64.so.* $(CURDIR)/debian/tmp/usr/lib/libcsound64.so

# avoid conflict with extract
install/csound-utils::
	mv $(CURDIR)/debian/tmp/usr/bin/extract \
		$(CURDIR)/debian/tmp/usr/bin/csound_extract

install/pd-csound::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pd/extra
	mv $(CURDIR)/debian/tmp/usr/lib/csoundapi~.pd_linux \
		$(CURDIR)/debian/tmp/usr/lib/pd/extra

install/libcsnd-java::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/java
	mv $(CURDIR)/debian/tmp/usr/lib/csnd.jar \
		$(CURDIR)/debian/tmp/usr/share/java/csnd-$(DEB_UPSTREAM_VERSION).jar
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/jni
	mv $(CURDIR)/debian/tmp/usr/lib/lib_jcsound.so \
		$(CURDIR)/debian/tmp/usr/lib/jni

install/python-csound::
	mkdir -p $(CURDIR)/debian/tmp/$(PYLIBPATH)
	cp csnd.py _csnd.so \
		$(CURDIR)/debian/tmp/$(PYLIBPATH)

install/liblua5.1-luacsnd5.2::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/lua/5.1/
	install luaCsnd.so $(CURDIR)/debian/tmp/usr/lib/liblua5.1-luacsnd.so.5.2
	ln -s ../../lua5.1-luacsnd.so.5.2 \
	       	$(CURDIR)/debian/tmp/usr/lib/lua/5.1/luaCsnd.so

install/libcsnd-dev::
